unit HandOffReport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, QuickRpt, Qrctrls;

type
  TfrmReport = class(TForm)
    QuickRep1: TQuickRep;
    QRBand1: TQRBand;
    QRSysData1: TQRSysData;
    QRBand2: TQRBand;
    QRMemo1: TQRMemo;
    QRMemo2: TQRMemo;
    QRMemo3: TQRMemo;
    QRMemo4: TQRMemo;
    QRBand3: TQRBand;
    QRSysData2: TQRSysData;
    QRSysData3: TQRSysData;
    QRShape1: TQRShape;
    QRShape2: TQRShape;
    QRShape3: TQRShape;
    QRShape4: TQRShape;
    QRCompositeReport1: TQRCompositeReport;
    procedure FormCreate(Sender: TObject);
    procedure QuickRep1NeedData(Sender: TObject; var MoreData: Boolean);
    procedure QuickRep1BeforePrint(Sender: TCustomQuickRep;
      var PrintReport: Boolean);
  private
    { Private declarations }

    PatDemoList: TStringlist;
    PatAllergies : TStringlist;
    PatMedications : TStringlist;
    PatCodeStatus: TStringlist;
    CurrentIndex: integer;
    Report : TCustomQuickRep;
  public
    { Public declarations }
        PatList : TStrings;
  end;

var
  frmReport: TfrmReport;
procedure PrintReport(FList: TStrings);

implementation

{$R *.DFM}
uses OrNet, ORfn,  ListSelection;

procedure PrintReport(FList: TStrings);
var
frmReport: TfrmReport;
begin
frmReport := TfrmReport.Create(Application);
frmReport.PatList := FList;
//frmReport.FormStyle := fsStayOnTop;
frmReport.QuickRep1.Q
TCustomQuickRep(frmReport.QRCompositeReport1);
frmReport.QRCompositeReport1.preview;
end;

procedure TfrmReport.FormCreate(Sender: TObject);
var
  i: integer;
   DataArray : TStringList;
begin
    PatDemoList:= TStringlist.Create;
    PatAllergies := TStringlist.Create;
    PatMedications := TStringlist.Create;
    PatCodeStatus:= TStringlist.Create;


end;

procedure TfrmReport.QuickRep1NeedData(Sender: TObject;
  var MoreData: Boolean);
var
pdemo : String;
begin
 MoreData := (CurrentIndex < PatList.Count);

  if MoreData then
  begin
  //Patient demographic data
  //DFN_U_NAME_U_SSN_U_DOB_U_AGE_U_SEX_U_RM_U_TSP_U_ATTN_U_PCP_U_WARD_U_ADMDT_U_$G(ADMDAY)_U_ADMDX
       tCallV(PatDemoList,'CRHD PAT DEMO',[PatList[CurrentIndex] + '^'+ '2,3,4,5,6,7,8,9,10,12' ]);
       tCallV(PatAllergies,'CRHD PAT ALLERGIES',[PatList[CurrentIndex]+ '^' + '0^0' ]);
       tCallV(PatMedications,'CRHD PAT ACTMEDS',[PatList[CurrentIndex] + '^' + '0^0^0^0^0']);
       tCallV(PatCodeStatus,'CRHD PAT CODESTS',[PatList[CurrentIndex] + '^' + '^' + frmPrintList.vDiv]);
    QuickRep1.QRPrinter.Progress := (Longint(CurrentIndex) * 100) div PatList.Count;
  end
  else
    QuickRep1.QRPrinter.Progress := 100;

  Inc(CurrentIndex);
end;

procedure TfrmReport.QuickRep1BeforePrint(Sender: TCustomQuickRep;
  var PrintReport: Boolean);
begin
CurrentIndex := 0;
end;

end.
