unit frmPrintReport;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RpRave, RpDefine, RpBase, RpSystem, RpCon, StdCtrls, Util, RpDevice;

type
  TfrmReportM = class(TForm)
    RvSystem1: TRvSystem;
    RvProject: TRvProject;
    RvCConnection: TRvCustomConnection;
    procedure RvCConnectionOpen(Connection: TRvCustomConnection);
    procedure RvCConnectionGetRow(Connection: TRvCustomConnection);
    procedure RvCConnectionGetCols(Connection: TRvCustomConnection);
    procedure RvProjectCreate(Sender: TObject);
  private
    { Private declarations }
    TitlesNum : integer;
    MainContact : TStringList;
    OtherContact : TStringList;
    PatDemo : TStringList;
    MedCol1 : TStringList;
    MedCol2 : TStringList;
    function GetTeamName(ListNm : String): String;
    function GetUserContactInfo(User : String): String;
    function GetContactInfo(ListNm : String): TStrings;
    function GetPatDemo(indx: integer): String;
    function GetAllergies(indx : integer): TStrings;
    function GetCodeStatus(indx: integer): TStrings;
    function GetCoveringPhy(indx: integer) : String;
    function GetMedication(indx: integer): TStrings;
    procedure GetData(Lst: TStrings; RPC, value: String);
    function GetTempfld(indx: integer; fldname : String): TStrings;
    procedure SizeProcess(PL : String);
    Function PrintText(TextToPrint: string): string;
  public
    { Public declarations }
    XM : Boolean;
    ListName : String;
    SomeList: TStrings;
    ListTitle : String;
    Procedure SortList(Slist, rlist: TStrings; flg: String);
    Procedure PrintMyReport(ListNme : String);
  end;


var
  frmReportM: TfrmReportM;
  PatArray: array of String;
  ListN : array of String;


implementation

{$R *.dfm}

uses Orfn, OrNet, frmMain, frmPrintData;

const
  MAX_CHAR_PRINT = 750;


function TfrmReportM.GetAllergies(indx: integer): TStrings;
var
xList : TStrings;
begin
  xList := TStringList.Create;
  GetData(xList,'CRHD PAT ALLERGIES', piece(PatArray[indx],'^',1)+ '^' + '0^0');
  Result := TStringList.Create;
  if xList.count > 0 then
    begin
      xList.Delete(0);
      Result:= xList;
    end;
end;

function TfrmReportM.GetCodeStatus(indx: integer): TStrings;
var
xList : TStrings;
uDiv : String;
begin
  xList := TStringList.Create;

  if (pos('^DIV', frmListSelect.Pref)>0 )or (pos(';DIC(4,', frmListSelect.Pref)>0 ) then uDiv := piece(piece(frmListSelect.Pref,'^',2),';',1)
  else uDiv := piece(frmListSelect.vDiv,'^',1);

  GetData(xList,'CRHD PAT CODESTS', piece(PatArray[indx],'^',1) + '^' + '^'+ piece(frmListSelect.vDiv,'^',1) + '^256^1^'+ IntToStr(frmListSelect.UserPar.MULTI_DNR));
  Result := TStringList.Create;
  if xList.count > 0 then
    begin
      xList.delete(0);
      Result:= xList;
    end;
end;

function TfrmReportM.GetContactInfo(ListNm: String): TStrings;
var
str1, str2, ph : String;
i, i2 ,n : integer;
tmpList : TStrings;
tmpCList : TStrings;
tmpCList2 : TStrings;
begin
  n := 0;
  Result := TStringList.Create;
  if MainContact = nil then  MainContact := TStringList.Create;
  if OtherContact = nil then  OtherContact := TStringList.Create;

  tmpList := TStringList.Create;
  tmpList.Clear;
  MainContact.Clear;
  OtherContact.Clear;
  if (pos('^HOTEAM',ListNm)>0) then
    begin
      n :=7;
      tCallV(tmpList,'CRHD HOT PROVIDER LIST', [ListNm]);
    end
    else
     if (pos('^Combination',ListNm)>0) then
      begin
       tmpCList := TStringList.Create;
       tmpCList2 := TStringList.Create;
       tCallv(tmpCList, 'CRHD COMB TM LIST', []);
       if tmpCList.Count > 0 then
       for i := 0 to tmpCList.Count -1 do
        begin
         tmpCList2.Clear;
         tCallV(tmpCList2,'CRHD TM PRV LIST', [tmpCList[i]]);
         n := 5;
         if tmpCList2[0]='No list found' then tmpCList2.Clear;
         if tmpCList2.Count > 0 then
         for i2 := 0 to tmpCList2.Count -1 do
         if not findDup(piece(tmpCList2[i2],'^',2),tmpList) then tmpList.Append(tmpCList2[i2]);
        end;
      end
     else
      begin
       tCallV(tmpList,'CRHD TM PRV LIST', [ListNm]);
       n :=5;
      end;

    if tmpList.Count=1 then
      if tmpList[0]='No list found' then tmpList.Clear;

      if tmpList.count=0 then
       begin
        MainContact.AddStrings(frmListSelect.UserPar.RESIDENT);
        OtherContact.AddStrings(frmListSelect.UserPar.STUDENT);
       end;

    if tmpList.Count > 0 then
    begin
     MixedCaseByPiece(tmpList, '^', 2);
     for i := 0 to tmpList.count -1 do
      begin
        str1 := tmpList[i];
        ph := '';
        if (piece(str1,'^',n) <> '') and (piece(str1,'^',n)<> '0')  then ph := 'Pg: ' + piece(str1,'^',n)
        else
        if (piece(str1,'^',n-1) <> '') and (piece(str1,'^',n-1)<> '0') then ph := 'Ph: ' + piece(str1,'^',n-1);

        if (ph = 'Pg: ') or (ph='Ph: ') then ph := '';
        if piece(str1,'^',3) <> '' then str2 := format('%s (' + copy(piece(str1,'^',3),1,1) + ')  %s', [piece(str1,'^',2),ph])
        else  str2 := format( '%s %s',[piece(str1,'^',2),ph]);

        if piece(str1 ,'^',3)='ATTN' then MainContact.Add(str2);
        if piece(str1 ,'^',3)= 'RES' then MainContact.Add(str2);
        if piece(str1 ,'^',3)= 'INTERN' then MainContact.Add(str2);
        if piece(str1 ,'^',3)= 'FELLOW' then MainContact.Add(str2);
        if piece(str1 ,'^',3)= 'MED STUDENT' then OtherContact.Add(str2);
        if piece(str1,'^',3)= 'NURSE' then OtherContact.Add(str2);
        if piece(str1,'^',3) = '' then OtherContact.Add(str2);
       end;
   end;
end;

function TfrmReportM.GetCoveringPhy(indx: integer): String;
var
xlist : TStrings;
begin
  xList := TStringList.Create;
  GetData(xList, 'CRHD GET TEMP FLD', 'Covering Physician' + '^' + frmListSelect.DUZ + '^' +  piece(PatArray[indx],'^',1)+ '^30^'+ frmListSelect.vDiv);
  if xList.count >0 then
          begin
            xList.Delete(0);
            if xList.count > 0 then
             if xList[0] <> '' then
              begin
               Result :='C_Phy: ' + xList[0];
              end;
          end;
end;

procedure TfrmReportM.GetData(Lst: TStrings; RPC, value: String);
begin
if pos('~NOTE DATA~',value)>0 then tCallV(Lst,'CRHD GET TIU TEXT', [piece(value,'^',3), ''])
else tCallV(Lst,RPC ,[value]);
end;

function TfrmReportM.GetMedication(indx: integer): TStrings;
var
xList : TStrings;
i : integer;
NumCharReturn : String;
begin
  xList := TStringList.Create;
  if MedCol1 = nil then MedCol1 := TStringList.Create;
  if MedCol2 = nil then MedCol2 := TStringList.Create;

  GetData(xList,'CRHD PAT ACTMEDS', piece(PatArray[indx],'^',1) + '^' + 'I^' + IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' + IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) + '^' + '40');
  Result := TStringList.Create;
  NumCharReturn := '30';
  if TitlesNum = 4 then
    NumCharReturn := '25';
  if xList.count > 0 then
    if Length(xList.Text)>(MAX_CHAR_PRINT*1.5) then GetData(xList,'CRHD PAT ACTMEDS', piece(PatArray[indx],'^',1) + '^' + 'I^' + IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' + IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) + '^' + NumCharReturn);

    MedCol1.Clear;
    MedCol2.Clear;
    if xList.count > 0 then
    begin
      xList.delete(0);
      if xList.Count > 0 then
        if pos('UNIT DOSE',xList[0]) > 0  then xList.delete(0);

      for i :=0 to xList.count -1 do
         begin
           if xList.count < 6 then MedCol1.Add(xList[i])
           else
             if i< (xList.count/2) then MedCol1.Add(xList[i])
             else
               MedCol2.Add(xList[i]);
        end;
    end;
end;


function TfrmReportM.GetPatDemo(indx: integer): String;
var
str : String;
begin
  if PatDemo = nil then PatDemo := TStringList.Create;
  PatDemo.Clear;
  str := pieces(PatArray[indx],'^',3,7) + '^' + pieces(PatArray[indx],'^',9,15);
  PiecesToList(str,'^',PatDemo);
  str :='';
  if pos('^HOTEAM', ListN[0])>0 then
  begin
    str := sCallV('CRHD HOT PATPRV', [ListN[0], piece(patArray[indx],'^',1)]);
    if piece(str,';',2)<> '' then PatDemo.Add('A: ' + piece(piece(str,';',2),'^',2));
    if piece(str,';',3)<> '' then PatDemo.Add('R: ' + piece(piece(str,';',3),'^',2));
    if piece(str,';',4)<> '' then PatDemo.Add('I: ' + piece(piece(str,';',4),'^',2));
    if piece(str,';',5)<> '' then PatDemo.Add('F: ' + piece(piece(str,';',5),'^',2));
    if piece(str,';',6)<> '' then PatDemo.Add('M: ' + piece(piece(str,';',6),'^',2));
    if piece(str,';',7)<> '' then PatDemo.Add('N: ' + piece(piece(str,';',7),'^',2));
  end;
  Result := piece(PatArray[indx],'^',8);
end;

function TfrmReportM.GetTeamName(ListNm: String): String;
var
tmpCList : TStrings;
i : integer;
begin
   Result := piece(ListNm,'^',2);

   if (pos('^Combination',ListNm)>0) then
     begin
       tmpCList := TStringList.Create;
       tCallv(tmpCList, 'CRHD COMB TM LIST', []);
       Result :='';
       if tmpCList.Count > 0 then
         for i := 0 to tmpCList.Count -1 do
        Result := Result + piece(tmpCList[i],'^',2) + ' - ';
     end;
end;

function TfrmReportM.GetTempfld(indx: integer; fldname: String): TStrings;
var
xList : TStrings;
begin
  xList := TStringList.Create;
  with frmListSelect.UserPar do
   begin
     GetData(xList, 'CRHD GET TEMP FLD', fldname + '^' + frmListSelect.DUZ + '^' +  piece(PatArray[indx],'^',1)+ '^' + '256');
     Result := TStringList.Create;
     if xList.count > 0 then
       begin
         xList.delete(0);
         Result := xList;
       end;
   end;
end;

function TfrmReportM.GetUserContactInfo(User:String): String;
var
tList : TStrings;
begin
  tList := TStringList.Create;
  tList.Clear;
  tCallV(tList,'CRHD ADDITIONAL USER INFO',[User]);
  if tList.Count > 0 then
    begin
       if piece(tList[0],'^',2)<> '' then Result := Result + ' Pager: ' + piece(tList[0],'^',2)
       else
       if piece(tList[0],'^',1) <> '' then  Result := Result + ' Office Ph: ' + piece(tList[0],'^',1)
    end;
end;

procedure TfrmReportM.PrintMyReport(ListNme: String);
var
I : integer;
begin
 SetLength(PatArray, SomeList.Count) ;
for I := 0 to SomeList.Count - 1 do
  PatArray[I] := SomeList[I];

  SetLength(ListN, 1);
  ListN[0] := ListNme;
  RPDev.SetPaperSize(DMPAPER_LETTER, 0, 0);
  RvProject.Execute;
end;

procedure TfrmReportM.RvCConnectionGetCols(Connection: TRvCustomConnection);
begin
   With Connection do
   begin
      WriteField('ListName',dtString,30,'ListName','');
      WriteField('User',dtString,30,'User','');
      WriteField('UserContact',dtString,50,'UserContact','');
      WriteField('Contact1',dtMemo,500,'Contact1','');
      WriteField('Contact2',dtMemo,500,'Contact2','');
      WriteField('PatientName',dtString,30,'PatientName','');
      WriteField('SSN',dtString,15,'SSN','');
      WriteField('PatDemo', dtMemo, 500, 'Patient Info', '');
      WriteField('Allergies',dtMemo, 500,'Allergies','');
      WriteField('CodeStatus',dtMemo,500,'CodeStatus','');
      WriteField('Medication',dtMemo,500,'Meds','');
      if XM then WriteField('Medication2',dtMemo,500,'Meds2','');
      WriteField('CoveringPhy',dtString,30,'CoveringPhy','');
      WriteField('lblTemp1',dtString,15,'lblTemp1','');
      WriteField('lblTemp2',dtString,15,'lblTemp2','');
      WriteField('lblTemp3',dtString,15,'lblTemp3','');
      WriteField('lblTemp4',dtString,15,'lblTemp4','');
      if frmListSelect.UserPar.TEMP_FLD_1_TITLE <> '' then WriteField('Temp1',dtMemo,500,'Temp1','');
      if frmListSelect.UserPar.TEMP_FLD_2_TITLE <> '' then WriteField('Temp2',dtMemo,500,'Temp2','');
      if frmListSelect.UserPar.TEMP_FLD_3_TITLE <> '' then WriteField('Temp3',dtMemo,500,'Temp3','');
      if frmListSelect.UserPar.TEMP_FLD_4_TITLE <> '' then WriteField('Temp4',dtMemo,500,'Temp4','');
   end;
end;


{     Order of write
      'ListName',dtString,30-'User',dtString,30-'UserContact',dtString,50
      'Contact1',dtMemo,500-'Contact2',dtMemo,500-'PatDemo1', dtMemo, 500
      'PatDemo2', dtMemo, 500-'Allergies',dtMemo, 500-'CodeStatus',dtMemo,500
      'Medication',dtMemo,500-'CoveringPhy',dtString,30-'lblTemp1',dtString,15
      'lblTemp2',dtString,15-'lblTemp3',dtString,15-'lblTemp4',dtString,15
      'Temp1',dtMemo,500-'Temp2',dtMemo,500-'Temp3',dtMemo,500-'Temp4',dtMemo,500}

procedure TfrmReportM.RvCConnectionGetRow(Connection: TRvCustomConnection);
var
  Buffer : PChar;
  i, n, nx: integer;
  str,str2,ph : String;
  tList : TStrings;
  ov: String;
begin
  ov := '';
  ListTitle := 'ListName';
  tList := TStringlist.Create;
  with connection do
    begin
      ListName := ListN[0];
      WriteStrData(GetTeamName(ListName),'');                           //ListName                          //ListName
      WriteStrData(piece(frmListSelect.User,'^',2),'');                 //User
      WriteStrData(GetUserContactInfo(frmListSelect.DUZ),'');           //User contact

      tList.Clear;
      GetContactInfo(ListName);
      MainContact.Text := RemoveChar(MainContact.Text, MainContact.LineBreak, Chr(13)) ;                                         //Contact box 1
      GetMem(Buffer, Length(MainContact.Text) +1);
      StrCopy(Buffer, PChar(MainContact.Text));
      Connection.WriteBlobData(Buffer^,Length(MainContact.Text));


      OtherContact.Text := RemoveChar(OtherContact.Text, OtherContact.LineBreak, Chr(13)) ;
      GetMem(Buffer, Length(OtherContact.Text) +1);                 //Contact box 2
      StrCopy(Buffer, PChar(OtherContact.Text));
      Connection.WriteBlobData(Buffer^,Length(OtherContact.Text));

      WriteStrData(piece(PatArray[Connection.DataIndex],'^',2),''); //Patient
      WriteStrData(GetPatDemo(Connection.DataIndex),'');            //SSN

      //data come from GetPatDemo called from line above
      GetMem(Buffer, Length(PatDemo.Text) +1);
      PatDemo.Text := PrintText(RemoveChar(PatDemo.Text, PatDemo.LineBreak, Chr(13))) ;  //Patient Demographics
      StrCopy(Buffer, PChar(PatDemo.Text));
      Connection.WriteBlobData(Buffer^,Length(PatDemo.Text));

      tList.Clear;
      tList  := GetAllergies(Connection.DataIndex);                //Allergies
      tList.Text := PrintText(RemoveChar(tList.Text, tList.LineBreak, Chr(13))) ;
      GetMem(Buffer, Length(tList.Text) +1);
      StrCopy(Buffer, PChar(tList.Text));
      Connection.WriteBlobData(Buffer^, Length(tList.Text));

      tList.Clear;
      tList := GetCodeStatus(Connection.DataIndex);              //CodeStatus
      tList.Text := PrintText(RemoveChar(tList.Text, tList.LineBreak, Chr(13))) ;
      GetMem(Buffer, Length(tList.Text) +1);
      StrCopy(Buffer, PChar(tList.Text));
      Connection.WriteBlobData(Buffer^, Length(tList.Text));

      tList.Clear;
      tList := GetMedication(Connection.DataIndex);            //Medications
      MedCol1.Text := PrintText(RemoveChar(MedCol1.Text, MedCol1.LineBreak, Chr(13)));
      GetMem(Buffer, Length(MedCol1.Text)+1);
      StrCopy(Buffer, PChar(MedCol1.Text));
      Connection.WriteBlobData(Buffer^, Length(MedCol1.Text));

     if XM then
      begin                                                         //Medications column 2
        MedCol2.Text := PrintText(RemoveChar(MedCol2.Text,MedCol2.LineBreak, Chr(13)));
        GetMem(Buffer, Length(MedCol2.Text)+1);
        StrCopy(Buffer, PChar(MedCol2.Text));
        Connection.WriteBlobData(Buffer^, Length(MedCol2.Text));
      end;



      WriteStrData(GetCoveringPhy(Connection.DataIndex),'');      //Covering Physician
      WriteStrData(frmListSelect.UserPar.TEMP_FLD_1_TITLE,'');  //Temp fld label1
      WriteStrData(frmListSelect.UserPar.TEMP_FLD_2_TITLE,'');  //Temp fld label2
      WriteStrData(frmListSelect.UserPar.TEMP_FLD_3_TITLE,'');  //Temp fld label3
      WriteStrData(frmListSelect.UserPar.TEMP_FLD_4_TITLE,'');  //Temp fld label4


      for I := 1 to 4 do                                          //Temp fld
        begin
         str := '';
         case I of
           1 : str := frmListSelect.UserPar.TEMP_FLD_1_TITLE;
           2 : str := frmListSelect.UserPar.TEMP_FLD_2_TITLE;
           3 : str := frmListSelect.UserPar.TEMP_FLD_3_TITLE;
           4 : str := frmListSelect.UserPar.TEMP_FLD_4_TITLE;
         end;

      if str <> '' then
        begin
          tList.Clear;
          tList := GetTempfld(Connection.DataIndex,str);
          tList.Text := PrintText(TextExtend(tList.Text,tList.LineBreak));

        { if Length(tList.Text) > MAX_CHAR_PRINT then
          begin
            ov := copy(tList.Text,MAX_CHAR_PRINT+1,(Length(tList.Text)-MAX_CHAR_PRINT));
            tList.Text := copy(tList.Text,1,MAX_CHAR_PRINT)+ char(13) + '***exceeds maximum print value***';
          end;
         }
          GetMem(Buffer, Length(tList.Text) +1);
          StrCopy(Buffer, PChar(tList.Text));
          Connection.WriteBlobData(Buffer^, Length(tList.Text));
        end;
     end;
    end;

 end;


Function TfrmReportM.PrintText(TextToPrint: string): string;
begin
  if Length(TextToPrint) > MAX_CHAR_PRINT then
  begin
   Result := copy(TextToPrint,1,MAX_CHAR_PRINT)+ char(13) + '***exceeds maximum print value***';
  end else Result := TextToPrint;
end;

procedure TfrmReportM.RvCConnectionOpen(Connection: TRvCustomConnection);
begin
  Connection.DataRows :=  High(PatArray)+ 1;
end;

procedure TfrmReportM.RvProjectCreate(Sender: TObject);
var
I     : integer;
PL    : String;                                                   //Page Orientation
mList : TStrings;
h     : integer;
s     : string;
begin
h := 0;
mList := TStringList.Create;

if frmListSelect.UserPar.PRINT_ORIENTATION = 'L' then PL := 'L'
else PL := 'P';

  for I := 1 to 4 do                                          //Temp fld
          case I of
            1 : if frmListSelect.UserPar.TEMP_FLD_1_TITLE <> '' then inc(TitlesNum);
            2 : if frmListSelect.UserPar.TEMP_FLD_2_TITLE <> '' then inc(TitlesNum);
            3 : if frmListSelect.UserPar.TEMP_FLD_3_TITLE <> '' then inc(TitlesNum);
            4 : if frmListSelect.UserPar.TEMP_FLD_4_TITLE <> '' then inc(TitlesNum);
          end;
  SizeProcess(PL);

         for I := 0 to  frmListSelect.ORLbxPatients.Count - 1 do
      begin
         mList.Clear;
         GetData(mList,'CRHD PAT ACTMEDS', piece(frmListSelect.ORLbxPatients.Items[I],'^',1) + '^' + 'I^'+ IntToStr(frmListSelect.UserPar.MED_EXCLUDE_IV) + '^0^0^' + IntToStr(frmListSelect.UserPar.MED_DETAIL_FLG) +'^20' );
         if mList.Count > 0 then mList.Delete(0);
         if mList.Count > 0 then
           if pos('UNIT DOSE',mList[0])> 0 then mList.Delete(0);


         if mList.Count  > h then h := mList.Count ;
      end;

     if h > 5 then  XM := True
      else XM := False;

  RvProject.Open;

   if XM then s := 'Report_' + PL + IntToStr(TitlesNum) + '_XM'
  else s := 'Report_'+ PL + IntToStr(TitlesNum) ;


  RvProject.SelectReport(s,True);

  RvProject.SetParam('TF1',frmListSelect.UserPar.TEMP_FLD_1_TITLE);
  RvProject.SetParam('TF2',frmListSelect.UserPar.TEMP_FLD_2_TITLE);
  RvProject.SetParam('TF3',frmListSelect.UserPar.TEMP_FLD_3_TITLE);
  RvProject.SetParam('TF4',frmListSelect.UserPar.TEMP_FLD_4_TITLE);
end;

procedure TfrmReportM.SizeProcess(PL : String);
begin
end;


procedure TfrmReportM.SortList(Slist, rlist: TStrings; flg: String);
begin
  if rlist = nil then rlist := TStringList.Create;
  tCallV(rlist,'CRHD SORT PRINT LIST' ,[Slist, flg ,frmListSelect.UserPar.PATIENT_DEMOGRAPHICS  + '^256^' + IntToStr(frmListSelect.UserPar.PATIENT_DEMO_PRINTLBL)]);
end;

end.
